using System;
using System.Collections.Generic;
using System.Text;

using System.Web.Services;
using System.Web.Services.Protocols;

namespace ImprovedBulkFieldChange
{
   class Program
   {
      static void Main(string[] args)
      {
         ttsoapcgi svr = null;
         long cookie = 0;
         
         try
         {
         	svr = new ttsoapcgi();

            CProject[] projs = svr.getProjectList("SOAPUser", "myPassword");
            cookie = svr.ProjectLogon(projs[0], "SOAPUser", "myPassword");

            // Get all the priority values
            CFieldValue[] priorities = svr.getDropdownFieldValuesForTable(cookie, "Defect", "Priority");
            // Get all the type values
            CFieldValue[] types = svr.getDropdownFieldValuesForTable(cookie, "Defect", "Type");

            CTableColumn[] cols = new CTableColumn[1];
            cols[0] = new CTableColumn();
            cols[0].name = "Record ID";
            
            CRecordListSoap lst = svr.getRecordListForTable(cookie, "Defect", "Not Prioritized", cols);

            // Grab the record ID for each defect in the list and update the priority
            for (int rowIdx = 0; rowIdx < lst.records.Length; rowIdx++)
            {
            	// Grab the record ID from our single column
                long id = long.Parse(lst.records[rowIdx].row[0].value);
            
                // Retrieve the edit object
                CDefect dft = svr.editDefectByRecordID(cookie, id, false);

               // Set Priority based on the Type
               dft.priority = priorities[FindIndexOfStr(types, dft.type)].value;
               
               // Save the defect to update it
               svr.saveDefect(cookie, dft);
               
               // Progress report
               Console.WriteLine("Defect with Record ID {0} was updated, {1} of {2} completed", id, rowIdx+1, lst.records.Length);
            }

         }
         catch (SoapException e)
         {
         	Console.WriteLine("Soap fault: {0} {1}", e.Detail.InnerText, e.Message.ToString());
         }
         catch (Exception e)
         {
         	Console.WriteLine(e.ToString());
         }
         finally
         {
         	try
             {
         		if (svr != null)
         			svr.DatabaseLogoff(cookie);
         	}
             catch (SoapException e)
             {
         		Console.WriteLine("Soap fault: {0} {1}", e.Detail.InnerText, e.Message.ToString());
         	}
             catch (Exception e)
             {
         		Console.WriteLine(e.ToString());
             }
         }
      }
      private static int FindIndexOfStr(CFieldValue[] values, String s)
      {
      	// Loop through the list of values and find the index of the given string
          int idx = 0;
          for (; idx < values.Length; idx++)
          {
      		if (values[idx].value == s)
                  break;
      	}
      
          return idx;
      }
   }
}
